define(["require", "exports", "tslib", "@sobotics/sotools/dist/sotools"], function (require, exports, tslib_1, sotools_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var genericBotUrl = 'https://so.floern.com/api/trackpost.php';
    var genericBotKey = 'Cm45BSrt51FR3ju';
    var GenericBotAPI = /** @class */ (function () {
        function GenericBotAPI(answerId) {
            this.answerId = answerId;
        }
        GenericBotAPI.prototype.ReportNaa = function () {
            return tslib_1.__awaiter(this, void 0, void 0, function () {
                var response;
                return tslib_1.__generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.makeTrackRequest()];
                        case 1:
                            response = _a.sent();
                            return [2 /*return*/, response];
                    }
                });
            });
        };
        GenericBotAPI.prototype.ReportRedFlag = function () {
            return tslib_1.__awaiter(this, void 0, void 0, function () {
                var response;
                return tslib_1.__generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.makeTrackRequest()];
                        case 1:
                            response = _a.sent();
                            return [2 /*return*/, response];
                    }
                });
            });
        };
        GenericBotAPI.prototype.ReportLooksFine = function () {
            return tslib_1.__awaiter(this, void 0, void 0, function () {
                return tslib_1.__generator(this, function (_a) {
                    return [2 /*return*/, false];
                });
            });
        };
        GenericBotAPI.prototype.ReportNeedsEditing = function () {
            return tslib_1.__awaiter(this, void 0, void 0, function () {
                return tslib_1.__generator(this, function (_a) {
                    return [2 /*return*/, false];
                });
            });
        };
        GenericBotAPI.prototype.computeContentHash = function (postContent) {
            if (!postContent) {
                return 0;
            }
            var hash = 0;
            for (var i = 0; i < postContent.length; ++i) {
                hash = ((hash << 5) - hash) + postContent.charCodeAt(i);
                hash = hash & hash;
            }
            return hash;
        };
        GenericBotAPI.prototype.makeTrackRequest = function () {
            var _this = this;
            var promise = new Promise(function (resolve, reject) {
                if (!sotools_1.IsStackOverflow()) {
                    resolve(false);
                }
                if ($('#answer-' + _this.answerId + ' .post-text').length === 0) {
                    resolve(false);
                }
                if ($('.top-bar .my-profile .gravatar-wrapper-24').length === 0) {
                    reject('Flag Tracker: Could not find username.');
                }
                var flaggerName = $('.top-bar .my-profile .gravatar-wrapper-24').attr('title');
                var contentHash = _this.computeContentHash($('#answer-' + _this.answerId + ' .post-text').html().trim());
                GM_xmlhttpRequest({
                    method: 'POST',
                    url: 'https://so.floern.com/api/trackpost.php',
                    headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
                    data: "key=" + genericBotKey
                        + '&postId=' + _this.answerId
                        + '&contentHash=' + contentHash
                        + '&flagger=' + encodeURIComponent(flaggerName),
                    onload: function (response) {
                        if (response.status !== 200) {
                            reject('Flag Tracker Error: Status ' + response.status);
                        }
                        resolve(true);
                    },
                    onerror: function (response) {
                        reject('Flag Tracker Error: ' + response.responseText);
                    }
                });
            });
            return promise;
        };
        return GenericBotAPI;
    }());
    exports.GenericBotAPI = GenericBotAPI;
});
